#include <stdio.h>
typedef struct headmap
{
  long AllSize;                /* OFF+ImageSize */
  long dummy;                  /* === 0    */
  long Off;                    /* 54+ClrUsed*4  */
  long Fix;                    /* === 0x28 */
  long Width;
  long Height;
  short Plane;                 /* === 1    */
  short Bit;                   /* 4,8,256  */
  long Compress;               /* === 0    */
  long ImageSize;              /* Width*Height*Bit/8 */
  long XPel;                   /* === 0xb6d*/
  long YPel;                   /* === 0xb6d*/
  long ClrUsed;                /*          */
  long ClrImportant;           /*          */
};

struct headmap head;
FILE *fp,*fp1;
char a[2][4];
long d[73];
short i,s_width,width,s_height,height;

main(ac,av)
short ac; char *av[];
{
  if(ac<3){
    printf("\n\tUsage: tobmp file out_file [s_width width s_height height]\n");
    printf("\n\t                     .bmp      0     2336    0      3200\n");
    exit(0);
  }
  fp=fopen(av[1],"rb");
  if(fp==0){ printf("\n\t input file not found!\n"); exit(0); }
  fp1=fopen(av[2],"wb");
  fread(&width,1,2,fp);
  width*=8;
  fread(&height,1,2,fp);
  s_width=s_height=0;

  if(ac>3)sscanf(av[3],"%d",&s_width);
  if(ac>4)sscanf(av[4],"%d",&width);
  if(ac>5)sscanf(av[5],"%d",&s_height);
  if(ac>6)sscanf(av[6],"%d",&height);
  printf("%d %d\n",width,height);

  fseek(fp,(long)292*s_height+4,0);

  head.dummy=0;                                      /* === 0    */
  head.Off=54+2*4;                                   /* 54+ClrUsed*4  */
  head.Fix=0x28;                                     /* === 0x28 */
  head.Width=width;
  head.Height=height;
  head.Plane=1;                                      /* === 1    */
  head.Bit=1;                                        /* 4,8,256  */
  head.Compress=0;                                   /* === 0    */
  head.ImageSize=head.Width*head.Height/8;           /* Width*Height*Bit/8 */
  head.XPel=0xb6d;                                   /* === 0xb6d*/
  head.YPel=0xb6d;                                   /* === 0xb6d*/
  head.ClrUsed=2;
  head.ClrImportant=2;
  head.AllSize=head.Off+head.ImageSize;              /* Off+ImageSize */
  fputc('B',fp1);
  fputc('M',fp1);
  fwrite(&head,1,52,fp1);
    a[0][0]=a[0][1]=a[0][2]=0;     a[0][3]=0;
    a[1][0]=a[1][1]=a[1][2]=0xff;  a[1][3]=0;
  fwrite(a,4,head.ClrUsed,fp1);

  for(i=0;i<height;i++){
    fread(d,4,73,fp);
    fwrite(&d[s_width/32],4,(width-1)/32+1,fp1);
  }
  fclose(fp);
  fclose(fp1);
}
